package ch.std.jumpstart.rest;

import java.util.HashMap;
import java.util.Map;

import javax.sql.DataSource;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.zaxxer.hikari.HikariConfigMXBean;
import com.zaxxer.hikari.HikariDataSource;

@RestController
@RequestMapping("/maintenance/info")
public class InfoController {

	@Value("${spring.application.name}")
	private String appName;
	
	@Autowired
	private DataSource dataSource;

	@GetMapping
	public Map<String, Object> get() {
		Map<String, Object> infoMap = new HashMap<>();
		infoMap.put("ApplicationName", this.appName);
		// get data source pool max size
		if (dataSource instanceof HikariDataSource) {
			HikariConfigMXBean hikariConfigMXBean = ((HikariDataSource) dataSource).getHikariConfigMXBean();
			infoMap.put("MaximumPoolSize", hikariConfigMXBean.getMaximumPoolSize());
		}
		return infoMap;
	}

}
